#! /usr/bin/env python
import rospy
import serial
import numpy
import time
from geometry_msgs.msg import Twist

L1 = 0.18 # meters - distance between left and right wheel divided by 2
L2 = 0.175 # meters - distance between front and rear wheel divided by 2
R = 0.078 # meters - wheel radius (not used)

A = [[1, 1, -(L1 + L2)],
    [1, -1, (L1 + L2)],
    [1, -1, (L1 + L2)],
    [1, 1, (L1 + L2)]]

vx = 0
vy = 0
theta = 0

B = [vx, vy, theta]

result = [0, 0, 0, 0]

def callback(data):
    global vx, vy, theta, B, A, result
    twist = Twist()
    vx = (data.linear.x)
    vy = (data.linear.y)
    vz = (data.angular.z)

    print(data.linear.x)

    B = [vx, vy, theta]
    result = numpy.matmul(A, B)
    # print(result)
    serialport.write(str(int(result[0]*100*-1)).encode() + "\n".encode())
    serialport.write(str(int(result[1]*100*-1)).encode() + "\n".encode())
    serialport.write(str(int(result[2]*100*-1)).encode() + "\n".encode())
    serialport.write(str(int(result[3]*100*-1)).encode() + "\n".encode())

    
def main():

    global serialport
    serialport = serial.Serial('/dev/ttyACM0', baudrate=9600)  # open serial port
    rospy.loginfo("Serial comunication")

    # starts the node
    rospy.init_node('robot_base')
    rospy.loginfo("Robot Base node started")

    rospy.Subscriber('/cmd_vel', Twist, callback)

    rospy.spin()

if __name__ == '__main__':
    main()
